petsc-3.10.5 2019-03-28
Report Typos and Errors

# MatGetDiagonal

Gets the diagonal of a matrix.

### Synopsis

    #include "petscmat.h"
    PetscErrorCode MatGetDiagonal(Mat mat,Vec v)

Logically Collective on Mat and Vec

### Input Parameters

| mat | - the matrix
| v | - the vector for storing the diagonal

### Output Parameter

v -the diagonal of the matrix

### Note

Currently only correct in parallel for square matrices.

### See Also

MatGetRow(), MatCreateSubMatrices(), MatCreateSubMatrix(), MatGetRowMaxAbs()

### Level

intermediate

### Location

src/mat/interface/matrix.c

### Examples

src/ksp/pc/examples/tutorials/ex1.c.html
src/ksp/pc/examples/tutorials/ex2.c.html
src/ksp/ksp/examples/tutorials/ex15.c.html
src/ksp/ksp/examples/tutorials/ex52.c.html
src/ksp/ksp/examples/tutorials/ex15f.F90.html
src/snes/examples/tutorials/ex70.c.html

### Implementations

MatGetDiagonal_MPIAIJ in src/mat/impls/aij/mpi/mpiaij.c
MatGetDiagonal_STRUMPACK in src/mat/impls/aij/mpi/strumpack/strumpack.c
MatGetDiagonal_SeqAIJ in src/mat/impls/aij/seq/aij.c
MatGetDiagonal_MPIBAIJ in src/mat/impls/baij/mpi/mpibaij.c
MatGetDiagonal_SeqBAIJ in src/mat/impls/baij/seq/baij2.c
MatGetDiagonal_Composite in src/mat/impls/composite/mcomposite.c
MatGetDiagonal_MPIDense in src/mat/impls/dense/mpi/mpidense.c
MatGetDiagonal_SeqDense in src/mat/impls/dense/seq/dense.c
MatGetDiagonal_Elemental in src/mat/impls/elemental/matelem.cxx
MatGetDiagonal_IS in src/mat/impls/is/matis.c
MatGetDiagonal_MFFD in src/mat/impls/mffd/mffd.c
MatGetDiagonal_Nest in src/mat/impls/nest/matnest.c
MatGetDiagonal_Normal in src/mat/impls/normal/normm.c
MatGetDiagonal_MPISBAIJ in src/mat/impls/sbaij/mpi/mpisbaij.c
MatGetDiagonal_SeqSBAIJ in src/mat/impls/sbaij/seq/sbaij2.c
MatGetDiagonal_MPISELL in src/mat/impls/sell/mpi/mpisell.c
MatGetDiagonal_SeqSELL in src/mat/impls/sell/seq/sell.c
MatGetDiagonal_Shell in src/mat/impls/shell/shell.c
Index of all Mat routines
Table of Contents for all manual pages
Index of all manual pages